#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

int main()
{
    // leeren String-Vektor anlegen
    vector<string> satz;

    // ausreichend Platz reservieren
    satz.reserve (5);

    // verschiedene Elemente hinten einfuegen
    satz.push_back ("Hallo,");
    satz.push_back ("wie");
    satz.push_back ("geht");
    satz.push_back ("es");
    satz.push_back ("?");

    // Elemente durch Leerzeichen getrennt ausgeben
    copy (satz.begin(), satz.end(),
          ostream_iterator<string>(cout," "));
    cout << endl;

    // "technische Daten" ausgeben
    cout << "  max_size(): " << satz.max_size() << endl;
    cout << "  size():     " << satz.size()     << endl;
    cout << "  capacity(): " << satz.capacity() << endl;

    // zweites und viertes Element vertauschen
    swap (satz[1], satz[3]);

    // vor "?" "immer" einfuegen
    satz.insert (find(satz.begin(),satz.end(),"?"),
                 "immer");

    // dem letzten Element "!" zuweisen
    satz.back() = "!";
    
    // Elemente durch Leerzeichen getrennt ausgeben
    copy (satz.begin(), satz.end(),
          ostream_iterator<string>(cout," "));
    cout << endl;

    // "technische Daten" ausgeben
    cout << "  max_size(): " << satz.max_size() << endl;
    cout << "  size():     " << satz.size()     << endl;
    cout << "  capacity(): " << satz.capacity() << endl;
}
