#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

#ifdef ALTES_DISTANCE
#include "distance.h"
#endif

int main()
{
    list<int> menge;

    /* Elemente 6 bis 1 und 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; ++i) {
        menge.push_front(i);    // vorne absteigend
        menge.push_back(i);     // hinten aufsteigend
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Elemente mit dem Wert 3 entfernen
     *  - neues Ende merken
     */
    list<int>::iterator ende;
    ende = remove (menge.begin(), menge.end(), 3);

    /* nur nicht-entfernte Elemente der Menge ausgeben
     */
    copy (menge.begin(), ende,
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Anzahl entfernter Elemente ausgeben
     */
    cout << "Anzahl entfernter Elemente: "
         << distance(ende,menge.end()) << endl;

    /* Elemente wirklich entfernen
     */
    menge.erase (ende, menge.end());

    /* modifizierte Menge komplett ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
