#include <iostream>
#include <deque>
#include <algorithm>
using namespace std;

int main()
{
    deque<int> menge;

    /* Elemente 1 bis 6 durcheinander in die Menge einfuegen
     */
    menge.push_back (3);
    menge.push_back (6);
    menge.push_back (5);
    menge.push_back (1);
    menge.push_back (4);
    menge.push_back (2);

    /* Menge von zu suchenden Werten
     */
    int suchmenge [] = { 1, 4, 6 };

    /* Elemente beider Mengen ausgeben
     */
    cout << "Menge:     ";
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl << "Suchmenge: ";
    copy (suchmenge, suchmenge+3,
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Elemente der Suchmenge in Menge suchen
     */
    deque<int>::iterator pos;
    pos = find_first_of (menge.begin(), menge.end(),
                         suchmenge, suchmenge+3);
    while (pos != menge.end()) {    
        // gefundene Element-Position ausgeben
        cout << (pos - menge.begin()) + 1 << ". Element "
             << "besitzt Wert der Suchmenge" << endl;
        // naechstes Element suchen
        pos = find_first_of (++pos, menge.end(),
                             suchmenge, suchmenge+3);
    }
}
