#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

int main()
{
    vector<int> menge1;
    list<int> menge2;

    /* Elemente 1 bis 6 in die erste Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge1.push_back(i);
    }

    /* zweite Menge: 1 2 4 8 16 3
     */
    for (int i=1; i<=16; i*=2) {
        menge2.push_back(i);
    }
    menge2.push_back(3);

    PRINT ("menge1: ", menge1);
    PRINT ("menge2: ", menge2);

    /* ersten Unterschied finden
     */
    pair<vector<int>::iterator,list<int>::iterator> werte;
    werte = mismatch (menge1.begin(), menge1.end(),
                      menge2.begin());
    if (werte.first == menge1.end()) {
        cout << "keine Unterschiede" << endl;
    }
    else {
        cout << "erster Unterschied: " << *werte.first << " und "
                                       << *werte.second << endl;
    }

    /* erste Stelle finden, an der das Element der ersten Menge
     * nicht kleiner-gleich dem Element der zweiten Menge ist
     */
    werte = mismatch (menge1.begin(), menge1.end(),
                      menge2.begin(),
                      less_equal<int>());
    if (werte.first == menge1.end()) {
        cout << "immer kleiner-gleich" << endl;
    }
    else {
        cout << "nicht kleiner-gleich: " << *werte.first << " und "
                                         << *werte.second << endl;
    }
}
