#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

class IntFolge {
  private:
    int wert;
  public:
    // Konstruktor
    IntFolge (int startwert) : wert(startwert) {
    }
    // "Funktionsaufruf"
    int operator() () {
        return wert++;
    }
};

int main()
{
    list<int> menge;

    /* Folge von 1 bis 9 einfuegen
     */
    generate_n (back_inserter(menge),    // Anfang
                9,                       // Anzahl
                IntFolge(1));            // generierte Werte

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* zweite bis vorletzte Element durch Folge ab 42 ersetzen
     */
    generate (++menge.begin(),          // Anfang
              --menge.end(),            // Ende
              IntFolge(42));            // generierte Werte

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
